Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologStatement.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologStatement.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologStatement.java	(revision 9)
@@ -45,7 +45,6 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.statements.Statement;
@@ -74,10 +73,10 @@
 	protected OoasCodeEmitter m_emitter = new OoasCodeEmitter();
 
 	@Override
-	public /*override*/ void visit(NondetBlock nondetBlock)
+	public void visit(NondetBlock nondetBlock)
 	{
 		int y = 0;
-		for (Statement x: nondetBlock.statements())
+		for (final Statement x: nondetBlock.statements())
 		{
 			if (y != 0)
 				m_emitter.Append("; ");
@@ -90,13 +89,13 @@
 	}
 
 	@Override
-	public /*override*/ void visit(SeqBlock seqBlock)
+	public void visit(SeqBlock seqBlock)
 	{
 		int y = 0;
 		if (seqBlock.symbols().symbolList().size() > 0)
 		{
 			m_emitter.Append("([");
-			for (Identifier sym: seqBlock.symbols().symbolList())
+			for (final Identifier sym: seqBlock.symbols().symbolList())
 			{
 				if (y != 0)
 					m_emitter.AppendLine(", ");
@@ -103,9 +102,9 @@
 				else
 					y++;
 
-				OoaPrologType atype = createTypeVisitor();
+				final OoaPrologType atype = createTypeVisitor();
 				sym.type().Accept(atype);
-				OoaPrologIdentifier anIdent = createIdentifierVisitor();
+				final OoaPrologIdentifier anIdent = createIdentifierVisitor();
 				sym.Accept(anIdent);
 				m_emitter.Append(String.format("%s:%s", anIdent.toString(), atype.toString()));
 			}
@@ -113,7 +112,7 @@
 		}
 
 		y = 0;
-		for (Statement x: seqBlock.statements())
+		for (final Statement x: seqBlock.statements())
 		{
 			if (y != 0)
 				m_emitter.AppendLine(", ");
@@ -129,10 +128,10 @@
 	}
 
 	@Override
-	public /*override*/ void visit(PrioBlock prioBlock)
+	public void visit(PrioBlock prioBlock)
 	{
 		int y = 0;
-		for (Statement x: prioBlock.statements())
+		for (final Statement x: prioBlock.statements())
 		{
 			if (y != 0)
 				m_emitter.Append("// ");
@@ -145,9 +144,9 @@
 	}
 
 	@Override
-	public /*override*/ void visit(GuardedCommand guardedCommand)
+	public void visit(GuardedCommand guardedCommand)
 	{
-		OoaPrologExpression expr = createExpressionVisitor();
+		final OoaPrologExpression expr = createExpressionVisitor();
 		guardedCommand.guard().Accept(expr);
 
 		m_emitter.AppendLineIncIndent(String.format("(%s%s) %s ",
@@ -162,14 +161,14 @@
 	}
 
 	@Override
-	public /*override*/ void visit(Assignment assignment)
+	public void visit(Assignment assignment)
 	{
 		if (assignment.nondetExpression() != null)
 			throw new NotImplementedException();
 
-		Iterator<Expression> aPlaceIt = assignment.places().iterator();
-		Iterator<Expression> aValueIt = assignment.values().iterator();
-		ArrayList<String> assignments = new ArrayList<String>();
+		final Iterator<Expression> aPlaceIt = assignment.places().iterator();
+		final Iterator<Expression> aValueIt = assignment.values().iterator();
+		final ArrayList<String> assignments = new ArrayList<String>();
 
 		while (aPlaceIt.hasNext())
 		{
@@ -176,11 +175,11 @@
 			final Expression aPlace = aPlaceIt.next();
 			final Expression aValue = aValueIt.next();
 
-			OoaPrologExpression prologPlace = createExpressionVisitor(true);
+			final OoaPrologExpression prologPlace = createExpressionVisitor(true);
 			aPlace.Accept(prologPlace);
 			assert(prologPlace.tmpVariables().size() == 1);
 
-			OoaPrologExpression prologValue = createExpressionVisitor();
+			final OoaPrologExpression prologValue = createExpressionVisitor();
 			aValue.Accept(prologValue);
 			assert(prologValue.tmpVariables().size() == 1);
 
@@ -213,7 +212,7 @@
 		}
 
 		int pos = 0;
-		for (String s: assignments)
+		for (final String s: assignments)
 		{
 			if (pos != 0)
 				m_emitter.Append(",");
@@ -223,11 +222,11 @@
 	}
 
 	@Override
-	public /*override*/ void visit(Call call)
+	public void visit(Call call)
 	{
-		Expression ce = call.callExpression();
+		final Expression ce = call.callExpression();
 		String callstatement = "";
-		StringBuilder parameter = new StringBuilder();
+		final StringBuilder parameter = new StringBuilder();
 		boolean hideCall = false;
 
 		if (ce.kind() == ExpressionKind.Identifier)
@@ -234,9 +233,9 @@
 			callstatement = ((IdentifierExpression)ce).identifier().tokenText();
 		else if (ce.kind() == ExpressionKind.Call)
 		{
-			CallExpression parens = (CallExpression)ce;
+			final CallExpression parens = (CallExpression)ce;
 
-			OoaPrologExpression prologexpr = createExpressionVisitor();
+			final OoaPrologExpression prologexpr = createExpressionVisitor();
 			parens.child().Accept(prologexpr);
 
 			if (parens.child().kind() == ExpressionKind.Identifier &&
@@ -243,7 +242,7 @@
 					((IdentifierExpression)parens.child()).identifier().kind() == IdentifierKind.NamedActionIdentifier)
 			{
 				// we need to hide internal actions
-				NamedActionIdentifier namedactionid = (NamedActionIdentifier)((IdentifierExpression)parens.child()).identifier();
+				final NamedActionIdentifier namedactionid = (NamedActionIdentifier)((IdentifierExpression)parens.child()).identifier();
 				hideCall = ((FunctionType)namedactionid.type()).functionType() == FunctionTypeEnum.Internal;
 			}
 
@@ -250,13 +249,13 @@
 			m_emitter.Append(prologexpr.toString());
 			callstatement = prologexpr.tmpVariables().get(0);
 			int i = 0;
-			for (Expression arg: parens.arguments())
+			for (final Expression arg: parens.arguments())
 			{
 				if (i != 0)
 					parameter.append(", ");
 				else
 					i++;
-				OoaPrologExpression paramexpr = createExpressionVisitor();
+				final OoaPrologExpression paramexpr = createExpressionVisitor();
 				arg.Accept(paramexpr);
 				m_emitter.Append(paramexpr.toString());
 				parameter.append(paramexpr.tmpVariables().get(0));
@@ -275,79 +274,26 @@
 	}
 
 	@Override
-	public /*override*/ void visit(SkipStatement skipStatement)
+	public void visit(SkipStatement skipStatement)
 	{
 		m_emitter.Append("skip");
 	}
 
 	@Override
-	public /*override*/ void visit(AbortStatement abortStatement)
+	public void visit(AbortStatement abortStatement)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(KillStatement killStatement)
+	public void visit(KillStatement killStatement)
 	{
 		throw new NotImplementedException();
 	}
 
 	@Override
-	public /*override*/ void visit(QualitativeConstraintStatement qalitativeConstraintStatement)
+	public String toString()
 	{
-		if (qalitativeConstraintStatement.tag)
-		{
-			m_emitter.Append("% observable assignment in actionhead");
-			return;
-		}
-
-		OoaPrologIdentifier id1 = createIdentifierVisitor();
-		OoaPrologIdentifier id2 = createIdentifierVisitor();
-		OoaPrologIdentifier id3 = createIdentifierVisitor();
-
-
-		switch (qalitativeConstraintStatement.operation())
-		{
-		case Deriv:
-			qalitativeConstraintStatement.variable0().Accept(id1);
-			qalitativeConstraintStatement.variable1().Accept(id2);
-			m_emitter.Append(String.format("%s := dt %s", id1.toString(), id2.toString()));
-			break;
-		case Diff:
-			qalitativeConstraintStatement.variable0().Accept(id1);
-			qalitativeConstraintStatement.variable1().Accept(id2);
-			qalitativeConstraintStatement.variable2().Accept(id3);
-			m_emitter.Append(String.format("%s := %s - %s", id1.toString(), id2.toString(), id3.toString()));
-			break;
-		case Equal:
-			qalitativeConstraintStatement.variable0().Accept(id1);
-			qalitativeConstraintStatement.variable1().Accept(id2);
-			m_emitter.Append(String.format("%s := %s", id1.toString(), id2.toString()));
-			break;
-
-		case Prod:
-			qalitativeConstraintStatement.variable0().Accept(id1);
-			qalitativeConstraintStatement.variable1().Accept(id2);
-			qalitativeConstraintStatement.variable2().Accept(id3);
-			m_emitter.Append(String.format("%s := %s * %s", id1.toString(), id2.toString(), id3.toString()));
-			break;
-
-		case Sum:
-			qalitativeConstraintStatement.variable0().Accept(id1);
-			qalitativeConstraintStatement.variable1().Accept(id2);
-			qalitativeConstraintStatement.variable2().Accept(id3);
-			m_emitter.Append(String.format("%s := %s + %s", id1.toString(), id2.toString(), id3.toString()));
-			break;
-
-		default:
-			throw new NotImplementedException();
-		}
-	}
-
-
-	@Override
-	public /*override*/ String toString()
-	{
 		return m_emitter.toString();
 	}
 
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prologsymbolic/OoaPrologSymbolicExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prologsymbolic/OoaPrologSymbolicExpression.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prologsymbolic/OoaPrologSymbolicExpression.java	(revision 9)
@@ -36,10 +36,9 @@
 import org.momut.ooas.ast.expressions.ValueExpression;
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.types.EnumType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.codegen.prolog.OoaPrologExpression;
@@ -80,7 +79,7 @@
 	}
 
 	// we need to map all other things to Prolog constructs
-	private String operatorString(Expression expression, UlyssesType resultingType)
+	private String operatorString(Expression expression, Type resultingType)
 	{
 		switch (expression.kind())
 		{
@@ -155,7 +154,7 @@
 
 	@SuppressWarnings("unchecked")
 	@Override
-	public /*override*/ <T> void visit(ValueExpression<T> valueExpression)
+	public <T> void visit(ValueExpression<T> valueExpression)
 	{
 		assert(m_tmpVars.size() == 0);
 		final String tmpVar = NewTempVariable();
@@ -178,19 +177,10 @@
 	}
 
 	@Override
-	public /*override*/ void visit(IdentifierExpression identifierExpression)
+	public void visit(IdentifierExpression identifierExpression)
 	{
-		if (identifierExpression.identifier().kind() == IdentifierKind.LandmarkIdentifier)
+		if (identifierExpression.identifier().kind() == IdentifierKind.EnumIdentifier)
 		{
-			final LandmarkIdentifier lmid = (LandmarkIdentifier)identifierExpression.identifier();
-			final OoaPrologIdentifier pid = createIdentifierVisitor();
-			lmid.Accept(pid);
-			//m_emitter.Append(pid.ToString());
-			m_tmpVars.add(pid.toString());
-			return;
-		}
-		else if (identifierExpression.identifier().kind() == IdentifierKind.EnumIdentifier)
-		{
 			final EnumIdentifier enumid = (EnumIdentifier)identifierExpression.identifier();
 			final EnumType enumType = (EnumType)enumid.type();
 			//m_emitter.Append(enumType.listOfEnumSymbols.IndexOf(enumid));
@@ -210,7 +200,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(UnaryOperator unaryOperator)
+	public void visit(UnaryOperator unaryOperator)
 	{
 		assert(m_tmpVars.size() == 0);
 		VisitSub(unaryOperator.child(), unaryOperator);
@@ -260,7 +250,7 @@
 	}
 
 	@Override
-	public /*override*/ void visit(BinaryOperator binaryOperator)
+	public void visit(BinaryOperator binaryOperator)
 	{
 		// eval stack must be empty
 		assert(m_tmpVars.size() == 0);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/Scratchbook.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/Scratchbook.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/Scratchbook.java	(revision 9)
@@ -29,11 +29,11 @@
 
 import java.util.HashSet;
 
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 
 public final class Scratchbook {
 	private int tmpVarCntr = 0;
-	final HashSet<UlyssesType> m_definedTypes = new HashSet<UlyssesType>();
+	final HashSet<Type> m_definedTypes = new HashSet<Type>();
 	final StringBuilder m_typeDefinitions = new StringBuilder();
 
 	public synchronized int getNewTmpVarCntrValue() {
@@ -40,6 +40,6 @@
 		tmpVarCntr++;
 		return tmpVarCntr;
 	}
-	public HashSet<UlyssesType> definedTypes() {return m_definedTypes;}
+	public HashSet<Type> definedTypes() {return m_definedTypes;}
 	public StringBuilder typeDefinitions() {return m_typeDefinitions;}
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaCustomParser.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaCustomParser.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/parser/ooaCustomParser.java	(revision 9)
@@ -50,7 +50,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.Quantifier;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
@@ -59,7 +58,6 @@
 import org.momut.ooas.ast.expressions.UnaryOperator;
 import org.momut.ooas.ast.expressions.UnresolvedIdentifierExpression;
 import org.momut.ooas.ast.expressions.ValueExpression;
-import org.momut.ooas.ast.expressions.QValConstructor.QValDeriv;
 import org.momut.ooas.ast.identifiers.AttributeIdentifier;
 import org.momut.ooas.ast.identifiers.ConstantIdentifier;
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
@@ -68,7 +66,6 @@
 import org.momut.ooas.ast.identifiers.Identifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
 import org.momut.ooas.ast.identifiers.IdentifierList;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -85,12 +82,9 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.statements.Statement;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement.QualitativeConstraintOperation;
-import org.momut.ooas.ast.types.AnyType;
 import org.momut.ooas.ast.types.BoolType;
 import org.momut.ooas.ast.types.CharType;
 import org.momut.ooas.ast.types.EnumType;
@@ -101,10 +95,9 @@
 import org.momut.ooas.ast.types.MapType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
 import org.momut.ooas.ast.types.FunctionType.FunctionTypeEnum;
 import org.momut.ooas.utils.exceptions.ArgumentException;
@@ -248,11 +241,11 @@
 				new ParserError(pState.filename, aToken, aMessage));
 	}
 
-	/* add warning message to state */
-	private void doWarning(Token id1, String p)
-	{
-		pState.AddWarningMessage(new ParserWarning(pState.filename, id1, p));
-	}
+//	/* add warning message to state */
+//	private void doWarning(Token id1, String p)
+//	{
+//		pState.AddWarningMessage(new ParserWarning(pState.filename, id1, p));
+//	}
 
 	private void doError(String aMessage)
 	{
@@ -302,7 +295,7 @@
 
 
 	/* create a named type; we're on top-level here */
-	 void createNamedType(Token aName, UlyssesType aType)
+	 void createNamedType(Token aName, Type aType)
 	{
 		// precond..
 		assert(aName != null);
@@ -454,7 +447,7 @@
 	}
 
 	/* add var symbol to the current action system */
-	void createAttribute(Token varname, boolean isStatic, boolean isObs, boolean isCtr, UlyssesType aType, Expression anExpr)
+	void createAttribute(Token varname, boolean isStatic, boolean isObs, boolean isCtr, Type aType, Expression anExpr)
 	{
 		if (!TosIsActionSystem())
 			return;
@@ -494,7 +487,7 @@
 
 	/* create an int type */
 	@SuppressWarnings("unchecked")
-	UlyssesType createIntType(Token rangeLow, Token rangeHigh)
+	Type createIntType(Token rangeLow, Token rangeHigh)
 	{
 		int low = 0;
 		int high = 0;
@@ -548,7 +541,7 @@
 
 	/* create a float type */
 	 @SuppressWarnings("unchecked")
-	UlyssesType createFloatType(Token rangeLow, Token rangeHigh)
+	Type createFloatType(Token rangeLow, Token rangeHigh)
 	{
 		float low = 0;
 		float high = 0;
@@ -606,7 +599,7 @@
 	}
 
 	/* create a list of an enumerated type */
-	 UlyssesType createListEnumType(Token alistelem)
+	 Type createListEnumType(Token alistelem)
 	{
 		final EnumType hiddenEnumType = new EnumType(null);
 
@@ -616,7 +609,7 @@
 	}
 
 	/* add a new enum symbol to a list with an anonymous enumerated type */
-	 void addToListEnumType(UlyssesType aTypeSymbol, Token otherlistelem)
+	 void addToListEnumType(Type aTypeSymbol, Token otherlistelem)
 	{
 		final EnumType enumtype = (EnumType)((ListType)aTypeSymbol).innerType();
 		addToEnumType(enumtype, otherlistelem, null);
@@ -623,7 +616,7 @@
 	}
 
 	/* create a new enumerated type */
-	 UlyssesType createEnumType(Token aRangeValue, Token anIntegerValue)
+	 Type createEnumType(Token aRangeValue, Token anIntegerValue)
 	{
 		EnumType result;
 
@@ -637,7 +630,7 @@
 	}
 
 	/* add a new enum symbol to the enumerated type */
-	 void addToEnumType(UlyssesType aTypeSymbol, Token otherRangeValue, Token anIntegerValue)
+	 void addToEnumType(Type aTypeSymbol, Token otherRangeValue, Token anIntegerValue)
 	{
 		final EnumType anEnum = (EnumType)aTypeSymbol;
 		if (anEnum.symbolTable().Defined(otherRangeValue.getText()))
@@ -685,9 +678,9 @@
 	}
 
 	/* get a named type */
-	 UlyssesType getNamedType(Token aType)
+	 Type getNamedType(Token aType)
 	{
-		UlyssesType result = null;
+		Type result = null;
 		final Identifier sym = pState.Lookup(aType);
 		if (sym == null)
 		{
@@ -705,7 +698,7 @@
 
 	/* create a list type */
 	 @SuppressWarnings("unchecked")
-	UlyssesType createListType(Token numOfElements, UlyssesType innertype)
+	Type createListType(Token numOfElements, Type innertype)
 	{
 		if (innertype == null)
 			doError(numOfElements, "List type lacks proper element type (null)");
@@ -740,7 +733,7 @@
 
 	/* create a map type */
 	 @SuppressWarnings("unchecked")
-	UlyssesType createMapType(Token numOfElements, UlyssesType mapfromtype, UlyssesType maptotype)
+	Type createMapType(Token numOfElements, Type mapfromtype, Type maptotype)
 	{
 		if (mapfromtype == null)
 			doError(numOfElements, "Map: From-type not set (null)");
@@ -772,7 +765,7 @@
 	}
 
 	/* create a tuple type */
-	 UlyssesType createTupleType(UlyssesType aType)
+	 Type createTupleType(Type aType)
 	{
 		final TupleType result = new TupleType(null);
 		addToTupleType(result, aType);
@@ -780,7 +773,7 @@
 	}
 
 	/* add inner type to tuple */
-	 void addToTupleType(UlyssesType aTypeSymbol, UlyssesType anotherType)
+	 void addToTupleType(Type aTypeSymbol, Type anotherType)
 	{
 		final TupleType tuple = (TupleType)aTypeSymbol;
 		if (anotherType != null)
@@ -789,30 +782,8 @@
 			doError("Unknown inner type in tuple");
 	}
 
-	/* create a QR type */
-	UlyssesType createQrType(Token alandmark)
-	{
-		final QrType result = new QrType(null);
-		addToQrType(result, alandmark);
-		return result;
-	}
-
-	/* add another landmark to QR type */
-	protected void addToQrType(UlyssesType aTypeSymbol, Token otherlandmark)
-	{
-		final Identifier sym = pState.Lookup(otherlandmark);
-		if (sym != null)
-		{
-			doError(otherlandmark, String.format("Redifinition of %s", otherlandmark.getText()));
-			return;
-		}
-
-		final LandmarkIdentifier lndmrk = new LandmarkIdentifier(otherlandmark, (QrType)aTypeSymbol, GetScope());
-		((QrType)aTypeSymbol).AddLandmark(lndmrk);
-	}
-
 	/* gets called after a simple type has been constructed. used to define an internal name*/
-	 void fixupSimpleType(UlyssesType aTypeSymbol)
+	 void fixupSimpleType(Type aTypeSymbol)
 	{
 		if (aTypeSymbol != null)
 			aTypeSymbol.SetupAnonymousName();
@@ -819,7 +790,7 @@
 	}
 
 	/* gets called after a simple or complex type has been constructed. used to define an internal name */
-	 void fixupComplexType(UlyssesType aTypeSymbol)
+	 void fixupComplexType(Type aTypeSymbol)
 	{
 		if (aTypeSymbol != null)
 			aTypeSymbol.SetupAnonymousName();
@@ -836,7 +807,7 @@
 			return null;
 		}
 
-		final FunctionType funtype = new FunctionType(FunctionTypeEnum.Method, new LinkedList<UlyssesType>(), null);
+		final FunctionType funtype = new FunctionType(FunctionTypeEnum.Method, new LinkedList<Type>(), null);
 		final MethodIdentifier msym = new MethodIdentifier(mname, funtype, GetScope());
 		// funtype.SetTypeIdentifier(msym); -- the type of this function doesn't have a name!
 
@@ -855,7 +826,7 @@
 
 
 	/* add a return type to a method */
-	 void setMethodReturnType(FunctionIdentifier newMethod, UlyssesType rt)
+	 void setMethodReturnType(FunctionIdentifier newMethod, Type rt)
 	{
 		if (newMethod == null)
 			return;
@@ -879,7 +850,7 @@
 	}
 
 	/* add a parameter to a method */
-	 void addMethodParameter(FunctionIdentifier newMethod, Token paramName, UlyssesType atype)
+	 void addMethodParameter(FunctionIdentifier newMethod, Token paramName, Type atype)
 	{
 		if (newMethod == null)
 			return;
@@ -932,7 +903,7 @@
 			return null;
 		}
 
-		final FunctionType atype = new FunctionType(actionType, new LinkedList<UlyssesType>(), null);
+		final FunctionType atype = new FunctionType(actionType, new LinkedList<Type>(), null);
 		final NamedActionIdentifier action = new NamedActionIdentifier(actionname, atype, GetScope());
 		// atype.SetTypeIdentifier(action); -- the type of this action doesn't have a name!
 
@@ -1275,7 +1246,7 @@
 	}
 
 	/* add block var */
-	 void addBlockVariable(Block seqList, Token varname, UlyssesType aType)
+	 void addBlockVariable(Block seqList, Token varname, Type aType)
 	{
 		if (aType == null)
 		{
@@ -1291,103 +1262,6 @@
 		}
 	}
 
-
-	 QualitativeConstraintStatement createTwoVarConstraintStatement(Token id1, Token id2, QualitativeConstraintOperation op)
-	{
-		Identifier var1 = pState.Lookup(id1);
-		if (var1 == null)
-		{
-			var1 = new ExpressionVariableIdentifier(id1.getText(), id1.getLine(), id1.getCharPositionInLine());
-			var1.SetType(new AnyType((ExpressionVariableIdentifier)var1));
-
-			GetScope().AddIdentifier(var1, null);
-
-			doWarning(id1, String.format("Free variable in qualitative constraint: '%s'.", id1.getText()));
-		}
-
-		Identifier var2 = pState.Lookup(id2);
-		if (var2 == null)
-		{
-			var2 = new ExpressionVariableIdentifier(id2.getText(), id2.getLine(), id2.getCharPositionInLine());
-			var2.SetType(new AnyType((ExpressionVariableIdentifier)var2));
-
-			GetScope().AddIdentifier(var2, null);
-
-			doWarning(id1, String.format("Free variable in qualitative constraint: '%s'.", id2.getText()));
-		}
-
-		final QualitativeConstraintStatement result = new QualitativeConstraintStatement(var1, var2, op, id1.getLine(), id1.getCharPositionInLine());
-		return result;
-	}
-
-
-	 QualitativeConstraintStatement createQualEqualConstraintStatement(Token id1, Token id2)
-	{
-		return createTwoVarConstraintStatement(id1, id2, QualitativeConstraintOperation.Equal);
-	}
-
-	 QualitativeConstraintStatement createQualArithConstraintStatement(Token id1, Token id2, Token id3, Token op)
-	{
-		Identifier var1 = pState.Lookup(id1);
-		if (var1 == null)
-		{
-			var1 = new ExpressionVariableIdentifier(id1.getText(), id1.getLine(), id1.getCharPositionInLine());
-			var1.SetType(new AnyType((ExpressionVariableIdentifier)var1));
-
-			GetScope().AddIdentifier(var1, null);
-
-			doWarning(id1, String.format("Free variable in qualitative constraint: '%s'.", id1.getText()));
-		}
-
-		Identifier var2 = pState.Lookup(id2);
-		if (var2 == null)
-		{
-			var2 = new ExpressionVariableIdentifier(id2.getText(), id2.getLine(), id2.getCharPositionInLine());
-			var2.SetType(new AnyType((ExpressionVariableIdentifier)var2));
-
-			GetScope().AddIdentifier(var2, null);
-
-			doWarning(id1, String.format("Free variable in qualitative constraint: '%s'.", id2.getText()));
-		}
-
-		Identifier var3 = pState.Lookup(id3);
-		if (var3 == null)
-		{
-			var3 = new ExpressionVariableIdentifier(id3.getText(), id3.getLine(), id3.getCharPositionInLine());
-			var3.SetType(new AnyType((ExpressionVariableIdentifier)var3));
-
-			GetScope().AddIdentifier(var3, null);
-
-			doWarning(id1, String.format("Free variable in qualitative constraint: '%s'.", id3.getText()));
-		}
-		QualitativeConstraintOperation operation;
-		switch (op.getType())
-		{
-		case ooaParser.T_SUM:
-			operation = QualitativeConstraintOperation.Sum;
-			break;
-		case ooaParser.T_DIFF:
-			operation = QualitativeConstraintOperation.Diff;
-			break;
-		case ooaParser.T_PROD:
-			operation = QualitativeConstraintOperation.Prod;
-			break;
-		default:
-			doError(op, String.format("'%s' unknown operation", op.getText()));
-			return null;
-		}
-
-		final QualitativeConstraintStatement result = new QualitativeConstraintStatement(var1, var2, var3, operation, id1.getLine(), id1.getCharPositionInLine());
-		return result;
-	}
-
-	 QualitativeConstraintStatement createQualDerivConstraintStatement(Token id1, Token derivid)
-	{
-		return createTwoVarConstraintStatement(id1, derivid, QualitativeConstraintOperation.Deriv);
-	}
-
-
-
 	/* creates a general binary operator without any children */
 	 BinaryOperator createBinaryOperator(ExpressionKind akind)
 	{
@@ -1424,7 +1298,7 @@
 	}
 
 	/* add a bound variable to the quantifier */
-	 void addBoundVarToQuantifierExpression(Quantifier result, Token id, UlyssesType id_type)
+	 void addBoundVarToQuantifierExpression(Quantifier result, Token id, Type id_type)
 	{
 		/*note: this might be a bit harsh, but for now it's easier to demand uniquely named vars,
                 without any hiding. Could be fixed in searching only the first resolve level for
@@ -1554,7 +1428,7 @@
 	}
 
 	/* add list comprehension variable */
-	 void addListComprVar(ListConstructor result, Token id, UlyssesType t1)
+	 void addListComprVar(ListConstructor result, Token id, Type t1)
 	{
 		final Identifier sym = pState.Lookup(id);
 		if (sym != null)
@@ -1636,7 +1510,7 @@
 	}
 
 	/* add local set compr. variable */
-	 void addSetComprVar(SetConstructor _set, Token id1, UlyssesType t1)
+	 void addSetComprVar(SetConstructor _set, Token id1, Type t1)
 	{
 		final Identifier sym = pState.Lookup(id1);
 		if (sym != null)
@@ -1739,59 +1613,8 @@
 		return new ObjectConstructor(atype, aname.getText(), anid.getLine(), anid.getCharPositionInLine());
 	}
 
-
-	 void setQualitativeDerivDec(QValConstructor result)
-	{
-		result.SetDerivation(QValDeriv.Dec);
-	}
-
-	 void setQualitativeDerivInc(QValConstructor result)
-	{
-		result.SetDerivation(QValDeriv.Inc);
-	}
-
-	 void setQualitativeDerivSteady(QValConstructor result)
-	{
-		result.SetDerivation(QValDeriv.Steady);
-	}
-
-	 void setQualitativeDerivDontCare(QValConstructor result)
-	{
-		result.SetDerivation(QValDeriv.DonTCare);
-	}
-
-	 void setQualitativeValueRangeInfinity(QValConstructor result, boolean p)
-	{
-		throw new NotImplementedException();
-	}
-
-	 void setQualitativeValueRange(QValConstructor result, Expression expr2)
-	{
-		result.AddRange(expr2);
-	}
-
-	 void setQualitativeValueInfinity(QValConstructor result, boolean minus)
-	{
-		throw new NotImplementedException();
-	}
-
-	 void setQualitativeValueLandmark(QValConstructor result, Expression expr)
-	{
-		result.SetValue(expr);
-	}
-
-	 void setQualitativeValueDontCare(QValConstructor result)
-	{
-		throw new NotImplementedException();
-	}
-
-	 QValConstructor createQualitativeValue(Token aval)
-	{
-		return new QValConstructor(aval.getLine(), aval.getCharPositionInLine());
-	}
-
 	/* add a local variable to a named action */
-	 void addLocalVariableToNamedAction(FunctionIdentifier newMethod, Token id1, UlyssesType t1)
+	 void addLocalVariableToNamedAction(FunctionIdentifier newMethod, Token id1, Type t1)
 	{
 		if (t1 == null)
 		{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCheckObjectRefsConstant.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCheckObjectRefsConstant.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaCheckObjectRefsConstant.java	(revision 9)
@@ -45,7 +45,7 @@
 import org.momut.ooas.ast.types.MapType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.TupleType;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserError;
 import org.momut.ooas.parser.ParserMessage;
 import org.momut.ooas.parser.ParserState;
@@ -137,7 +137,7 @@
 	}
 
 	private void check(TupleType type) {
-		for (final UlyssesType t: type.innerTypes())
+		for (final Type t: type.innerTypes())
 			switch (t.kind()) {
 			case ListType:
 				check( (ListType) t);
